<?php

namespace HCM\AVL\Services;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Error;
use HCM\Util\DateUtil;
use HCM\AVL\Repository\AnaliseApuracaoRepository;

class AnaliseApuracaoService {
    
    protected $entityManager;
    protected $hcmParameters;
    protected $AnaliseApuracaoRepository;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, AnaliseApuracaoRepository $AnaliseApuracaoRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->AnaliseApuracaoRepository = $AnaliseApuracaoRepository;
    }
    
    public function getApuracaoPonderada($parameters){
        $nravaliacao = $parameters["P_NRAVALIACAO"];
        $nrparcexecaval = $parameters["P_NRPARCEXECAVAL"];
        $nrparcavaliado = $parameters["P_NRPARCAVALIADO"];
        $nrparticipaval = $this->AnaliseApuracaoRepository->getNrparticipaval($parameters);
        if (isset($nrparticipaval[0])) {
            $parameters["P_NRPARTICIPAVAL"] = $nrparticipaval[0]["NRPARTICIPAVAL"];
            return $this->AnaliseApuracaoRepository->getApuracaoPonderada($parameters);
        } else
            return [];    
        
    }
}