<?php

namespace HCM\BTL\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;

class TipoProcessosController extends Crud {

    protected $dataSourceName = 'getTipoProcesso';
    
    public function __construct (Manager $dataSourceManager, HCMParameters $hcmParameters){
        $this->hcmParameters = $hcmParameters;
        parent::__construct($dataSourceManager);
    }

    public function setTipoProcesso(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (array_key_exists('NRTIPOPROCESSO', $row)) {
                    if ($row['NRTIPOPROCESSO'] === '') {
                        $row['NRTIPOPROCESSO'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'DES_TIPOPROCESSO', 1, 12, true); 
                    }
                } else {
                    $row['NRTIPOPROCESSO'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'DES_TIPOPROCESSO', 1, 12, true); 
                }
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function deleteTipoProcesso(DTO\Request\DataSet $request, DTO\Response $response){
        try{
            parent::delete($request, $response);
        } catch(\Exception $e){
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }   
    }

} 