<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\NovoCodigo;
use HCM\Util\HCMParameters;
use HCM\Util\DateUtil;

class LoteLancEventoRepository {

    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->connection    = $connection;
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    /**
     * @return array
     */
 
    public function deleteMarcacao($nrorg, $nrvinculo, $dtEntrada ) {
        $query = $this->entityManager->getConnection()->prepare("
          DELETE FROM GPE_MARCACAOPONTO WHERE NRORG = :NRORG AND NRVINCULOM = :NRVINCULOM AND TO_CHAR(DTHRMARCACAOPONTO, 'DD/MM/YYYY') = :DTHRMARCACAOPONTO
        ");

        $return = $query->execute(
            array(
                "NRORG"            => $nrorg,
                "NRVINCULOM" => $nrvinculo,
                "DTHRMARCACAOPONTO" => $dtEntrada
            )
        );
        return $return;
    }
    
    public function insertMarcacao($nrorg, $nrvinculom, $dthrmarcacaoponto, $dthrajustada, $qthrsdiurnas, $qthrsnoturnas, $qthrsextras, $perchrsextras, $idtphrextra, $qthrsextras2, $perchrsextras2, $idtphrextra2, $qthrsextras3, $perchrsextras3, $idtphrextra3, $qthrsextras4, $perchrsextras4, $idtphrextra4, $qthrsatrasos, $qthrscompensar, $idenquadrahorario = 'N', $idmarcdesprezada = 'N', $iddiaocorrencia = 'FC', $idativo = 'S', $nrcoletor = 24){
        $dtinclusao = DateUtil::getDataAtual();
        $nrorginclusao = ($this->hcmParameters->getNrorgTrabalho());
        $cdoperinclusao = $this->hcmParameters->getCdoperador();
        $dtultatu = DateUtil::getDataAtual();
        $nrorgultatu = $this->hcmParameters->getNrorgTrabalho();
        $cdoperultatu = $this->hcmParameters->getCdoperador();
        $nrmarcacaoponto = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'GPE_MARCACAOPONTO', 1, 12, true);
            
        
        $sql= $this->entityManager->getConnection()->prepare(
            "INSERT INTO GPE_MARCACAOPONTO (
                NRORG,
                NRMARCACAOPONTO,
                NRVINCULOM,
                DTHRMARCACAOPONTO,
                DTHRAJUSTADA,
                IDENQUADRAHORARIO,
                IDMARCDESPREZADA,
                IDDIAOCORRENCIA,
                IDATIVO,
                NRORGINCLUSAO,
                DTINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                DTULTATU,
                CDOPERULTATU,
                NRCOLETOR,
                QTHRSDIURNAS,
                QTHRSNOTURNAS,
                QTHRSEXTRAS,
                PERCHRSEXTRAS,
                IDTPHREXTRA,
                QTHRSEXTRAS2,
                PERCHRSEXTRAS2,
                IDTPHREXTRA2,
                QTHRSEXTRAS3,
                PERCHRSEXTRAS3,
                IDTPHREXTRA3,
                QTHRSEXTRAS4,
                PERCHRSEXTRAS4,
                IDTPHREXTRA4,
                QTHRSATRASOS,
                QTHRSCOMPENSAR) VALUES (
                    :NRORG,
                    :NRMARCACAOPONTO,
                    :NRVINCULOM,
                    :DTHRMARCACAOPONTO,
                    :DTHRAJUSTADA,
                    :IDENQUADRAHORARIO,
                    :IDMARCDESPREZADA,
                    :IDDIAOCORRENCIA,
                    :IDATIVO,
                    :NRORGINCLUSAO,
                    :DTINCLUSAO,
                    :CDOPERINCLUSAO,
                    :NRORGULTATU,
                    :DTULTATU,
                    :CDOPERULTATU,
                    :NRCOLETOR,
                    :QTHRSDIURNAS,
                    :QTHRSNOTURNAS,
                    :QTHRSEXTRAS,
                    :PERCHRSEXTRAS,
                    :IDTPHREXTRA,
                    :QTHRSEXTRAS2,
                    :PERCHRSEXTRAS2,
                    :IDTPHREXTRA2,
                    :QTHRSEXTRAS3,
                    :PERCHRSEXTRAS3,
                    :IDTPHREXTRA3,
                    :QTHRSEXTRAS4,
                    :PERCHRSEXTRAS4,
                    :IDTPHREXTRA4,
                    :QTHRSATRASOS,
                    :QTHRSCOMPENSAR)"    
        );

        $sql->execute(
            array(
                "NRORG"             =>      $nrorg,
                "NRMARCACAOPONTO"   =>      $nrmarcacaoponto,
                "NRVINCULOM"        =>      $nrvinculom,
                "DTHRMARCACAOPONTO" =>      $dthrmarcacaoponto->format("d/m/Y H:i:s"),
                "DTHRAJUSTADA"      =>      $dthrajustada->format("d/m/Y H:i:s"),
                "IDENQUADRAHORARIO" =>      $idenquadrahorario,
                "IDMARCDESPREZADA"  =>      $idmarcdesprezada,
                "IDDIAOCORRENCIA"   =>      $iddiaocorrencia,
                "IDATIVO"           =>      $idativo,
                "NRORGINCLUSAO"     =>      $nrorginclusao,
                "DTINCLUSAO"        =>      $dtinclusao->format("d/m/Y H:i:s"),
                "CDOPERINCLUSAO"    =>      $cdoperinclusao,
                "NRORGULTATU"       =>      $nrorgultatu,
                "DTULTATU"          =>      $dtultatu->format("d/m/Y H:i:s"),
                "CDOPERULTATU"      =>      $cdoperultatu,
                "NRCOLETOR"         =>      $nrcoletor,
                "QTHRSDIURNAS"      =>      $qthrsdiurnas,
                "QTHRSNOTURNAS"     =>      $qthrsnoturnas,
                "QTHRSEXTRAS"       =>      $qthrsextras,
                "PERCHRSEXTRAS"     =>      $perchrsextras,
                "IDTPHREXTRA"       =>      $idtphrextra,
                "QTHRSEXTRAS2"      =>      $qthrsextras2,
                "PERCHRSEXTRAS2"    =>      $perchrsextras2,
                "IDTPHREXTRA2"      =>      $idtphrextra2,
                "QTHRSEXTRAS3"      =>      $qthrsextras3,
                "PERCHRSEXTRAS3"    =>      $perchrsextras3,
                "IDTPHREXTRA3"      =>      $idtphrextra3,
                "QTHRSEXTRAS4"      =>      $qthrsextras4,
                "PERCHRSEXTRAS4"    =>      $perchrsextras4,
                "IDTPHREXTRA4"      =>      $idtphrextra4,
                "QTHRSATRASOS"      =>      $qthrsatrasos,
                "QTHRSCOMPENSAR"    =>      $qthrscompensar
            )
        );
    }
    
    public function getVinculos( $nrestrutlegal, $nrestrutgeren, $nrestrutsind, $dtmescompetencia, $nrorg, $nrtipohierarq, $nrestruthierarq)
    {
        try {
            $where = array();
            if (!empty($nrestrutlegal)) {
                $where[] = 'VH.NRESTRUTLEGAL = ' . $nrestrutlegal;
            }
            if (!empty($nrestrutgeren)) {
                $where[] = 'VH.NRESTRUTGEREN = ' . $nrestrutgeren;
            }
            if (!empty($nrestrutsind)) {
                $where[] = 'VH.NRESTRUTSIND = ' . $nrestrutsind;
            }
            if (!empty($nrestruthierarq)) {
                $where[] = 'EHA.NRESTRUTURAM = ' . $nrestruthierarq;
            }

            if(empty($where)) { //Se não houver parâmetros de estruturas não se deve exeutar o implode para não gerar um 'AND ...' orfão.
                $where = '';
            }else{
                $where = implode(' AND ', $where);
                $where = " AND $where";
            }

            $objs = $this->getVinculosH($where, $dtmescompetencia, $nrorg, $nrtipohierarq, $nrestruthierarq);

            if($objs){
                return $objs;
            }else{
                return false;
            }
            

        } catch (\Exception $e) {
            if($e->getCode() == self::AVISO){
                tk_message($e->getMessage(), 'error');
            }else{
                throw $e;
            }
        }
    }

    public function getVinculosH($where, $dtmescompetencia, $nrorg, $nrtipohierarq, $nrestruthierarq)
    {
        try {
            $params = array('P_NRORG'           => $nrorg,
                            'P_COMPETENCIA'     => $dtmescompetencia,
                            'P_NRTIPOHIERARQ'   => $nrtipohierarq);
                            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            
            $sql_1 = "SELECT * FROM GPE_VINCULOH VH JOIN GPE_VINCULOM VM ON VM.NRORG = VH.NRORG AND VM.NRVINCULOM = VH.NRVINCULOM AND ( VM.DTRESCISAOVINC >= LAST_DAY(:P_COMPETENCIA) OR VM.DTRESCISAOVINC IS NULL )";
            $sql_h = "JOIN ESTRUTURAH EHA ON EHA.NRORG = VH.NRORG AND EHA.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH WHERE DTMESCOMPETENC <= :P_COMPETENCIA AND NRORG = VH.NRORG AND NRESTRUTURAM = EHA.NRESTRUTURAM ) AND EHA.NRESTRUTURAM = ( SELECT MAX(H.NRESTRUTURAMSUP) FROM HIERARQUIAORG H WHERE H.NRORG = VH.NRORG AND H.NRESTRUTURAMREL = VH.NRESTRUTGEREN AND H.NRTIPOHIERARQORG = :P_NRTIPOHIERARQ AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG WHERE DTINIVIGENCIA <= LAST_DAY(:P_COMPETENCIA) AND NRORG = VH.NRORG AND NRESTRUTURAMREL = VH.NRESTRUTGEREN AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) )";
            $sql_2 = "WHERE VH.NRORG = :P_NRORG AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH WHERE DTMESCOMPETENC <= :P_COMPETENCIA AND NRORG = VH.NRORG AND NRVINCULOM = VH.NRVINCULOM )";
            $sql_3 = "ORDER BY VH.NRESTRUTLEGAL/*, VH.NRESTRUTGEREN*/, VM.NMVINCULOM";
            if(!empty($nrtipohierarq)){    //Rafael Pickbrenner PCK 25/09/2015 14121
                $sql = "$sql_1 $sql_h $sql_2 $where $sql_3";
            }else{
                //$where = "$where AND NRORG = :P_NRORG AND NRVINCULOH IN (SELECT NRVINCULOH FROM GPE_VINCULOH INNER JOIN GPE_VINCULOM ON GPE_VINCULOM.NRORG = GPE_VINCULOH.NRORG AND GPE_VINCULOM.NRVINCULOM = GPE_VINCULOH.NRVINCULOM WHERE TRUNC(GPE_VINCULOM.DTADMISSAOVINC, 'DD') <= :P_DTMESCOMPETENC AND (TRUNC(GPE_VINCULOM.DTRESCISAOVINC, 'DD') >= :P_DTMESCOMPETENC OR GPE_VINCULOM.DTRESCISAOVINC IS NULL) AND DTMESCOMPETENC = (SELECT MAX(MAX_VINCULOH.DTMESCOMPETENC) FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND TRUNC(MAX_VINCULOH.DTMESCOMPETENC, 'DD') <= :P_DTMESCOMPETENC AND MAX_VINCULOH.NRORG = :P_NRORG))";
                $sql = "$sql_1 $sql_2 $where $sql_3";
            }
            //$object = GpeVinculoh::getObjectsByWhere($where, $params, 'NRESTRUTGEREN, NRVINCULOM'); //Original, tipo objeto
            $object = $db->fetchAll($sql, $params)[0];
            if ($object) {
                return $object;
            } else {
                return false;
            }
        } catch (\Exception $e) {
            if($e->getCode() == self::AVISO){
                tk_message($e->getMessage(), 'error');
            }else{
                throw $e;
            }
        }
    }
    
}