<?php
/**
 * User: ArturMarcos
 * Date: 18/08/18
 * Time: 14:34
 * To change this template use File | Settings | File Templates.
 */

namespace HCM\Geral\Logic\Apolo;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;
use Zeedhi\Framework\Session\Session;
use HCM\Geral\Services\ESocialService;

class TransmissaoEsocial extends \Zeedhi\Queue\Producer{

    // Parametros de Rotas
    const IDTRANSMISSAO = 'idTransmissao';

    // Operações do eSocial
    const IDTRANSENVIO = 'ENVIAR'; //Enviar Evento
    const IDTRANSCONSU = 'CONSULTAR'; //Consultar Status do evento
    const IDTRANSREENV = 'REENVIAR'; //Reenviar Evento
    const IDTRANSEXCLU = 'EXCLUSAO'; //Excluir Evento
    
    protected static $queueName = "/queue/";
    protected $connection;
    private $hcmParameters;
    private $jenkins;
    private $entityManager;
    private $eSocialService;
    private $orgsEnvio = array();
    private $msg;
    
    public function __construct(HCMParameters $hcmParameters, ESocialService $eSocialService){
        $this->entityManager = \Setforms2\Shared\Registry::getEntityManager();
        $this->hcmParameters = $hcmParameters;
        
        $paramsApolo = FPA::getParamsApolo();
        
        $url = $paramsApolo['URL'];
        $port = $paramsApolo['PORT'];
        $user = $paramsApolo['USER'];
        $password = $paramsApolo['PASSWORD'];
        $broke = $paramsApolo['BROKE'];
        
        $this->connectionApolo = new \Zeedhi\Queue\Connection($url, $port, $user, $password, $broke);
        parent::__construct($this->connectionApolo);
        
        $this->eSocialService = $eSocialService;
        $this->jenkins = true;
        $this->envioCadastros = Repositories::ESO_ENVIOCADASTROS;
    }
    
    public function startaApolo($parametros){
        
        set_time_limit(0);
        error_reporting(E_ERROR | E_PARSE);
        
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
       
//        $registrosParametrosPorOrg = array();
        
//        $esoParametros = $this->entityManager->getRepository(Repositories::ESO_PARAMETRO)->getEsoParametro();
        
        //Separa registros da Eso parametro por organização.
//        foreach($esoParametros as $key => $esoParametro){
//            $registrosParametrosPorOrg[$esoParametro['NRORG']][] = $esoParametro;
//        }
        
        //Percorre Organizações
//        foreach ($registrosParametrosPorOrg as $nrorg => $parametros) {
//            $session = new Session();
//            
//            $parametersXml = simplexml_load_file(__DIR__.'/../../../../../config/parameters.xml');
//            
//            $ProjectVersion = (string)$parametersXml->parameters->parameter[2];
//            $this->hcmParameters = new HCMParameters($session, FPA::getTempDirectory(), null, $ProjectVersion);
//            $this->setParametrosHcm($nrorg);
//            FPA::setSession($this->hcmParameters->getSession());
            
            foreach ($parametros as $parametro) {
                $eventos = $this->entityManager->getRepository(Repositories::ESO_EVENTO)->getEventosESocial($parametro['DSVERSAO']);
                foreach ($eventos as $evento) {
                    $row = array_merge($evento, $parametro);
                    $this->setEnvioCadastros($row);
                }
            }
            
            $horaDisparo = DateUtil::getDataAtual()->format('YmdHis');
            self::$queueName = '/queue/hcm_envioEso_'.$nrorg.$horaDisparo;
            
            $params[$nrorg] = $parametros;
            
            $message = json_encode(array($params));
            
            $this->send($message);
            
            $consumidor = new consumidorTransmissaoEsocial($this->hcmParameters, $this->eSocialService, $this->entityManager, $this->connectionApolo, self::$queueName);
//        }
    }
    
    public function setEnvioCadastros($row) {
        try {
            $nrorg = $this->hcmParameters->getNrorgTrabalho();
            $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
            $nrtipoestrutlegal = $this->hcmParameters->getTipoEstruturaLegalOrg();
        
            $estruturaESocial = current($this->eSocialService->getEstruturasESocial(
                $nrorg, $dtmescompetenc, $nrtipoestrutlegal, $row['IDGRUPO'], 'AND NRESTRUTURAM = '.$row['NRESTRUTURAM']
            ));
            $row['CDCNPJEMPREGADOR'] = $estruturaESocial['CDCNPJEMPREGADOR'];
                
            $row['IDATIVO'] = isset($row['IDATIVO']) ? $row['IDATIVO'] : 'S';
            $row['DSDIRXMLENV'] = isset($row['DSDIRXMLENV']) ? $row['DSDIRXMLENV'] : null;
            $row['DSDIRXMLRETENV'] = isset($row['DSDIRXMLRETENV']) ? $row['DSDIRXMLRETENV'] : null;
            $row['DSDIRXMLRETPRO'] = isset($row['DSDIRXMLRETPRO']) ? $row['DSDIRXMLRETPRO'] : null;
            $row['DSDIRXMLRETTOT'] = isset($row['DSDIRXMLRETTOT']) ? $row['DSDIRXMLRETTOT'] : null;

            if ($row['NRTPAMBIENTE'] == '') {
                $paramESocial = $this->eSocialService->getParamESocial($row['NRESTRUTURAM']);
                if ($paramESocial) {
                    $row['NRTPAMBIENTE'] = $paramESocial['NRTPAMBIENTE'];
                }
            }
            
            if($row['NMEVPRECED']){
                $eventosPreced = explode(',', $row['NMEVPRECED']);
                foreach($eventosPreced as $eventoPreced){
                    $arrItens = $this->eSocialService->getItensParaEnvioEvento($eventoPreced, null, $row, $this->jenkins);
                    if ($arrItens) {
                        return;
                    }
                }
            }
            
            //verifica dependencia
            if($row['NMEVDEPEND']){
                $eventosDepend = explode(',', $row['NMEVDEPEND']);
                 foreach($eventosDepend as $eventoDepend){
                    $arrItens = $this->eSocialService->getItensParaEnvioEvento($eventoDepend, null, $row, $this->jenkins);
                    if (!$arrItens) {
                        return;
                    }
                }
            }
            
            //Verifica itens para envio.
            $arrItens = $this->eSocialService->getItensParaEnvioEvento($row['NMEVENTO'], $row['IDGRUPO'], $row, $this->jenkins);
            if (empty($arrItens)) {
                return;
            }
            
            echo 'Org:' . $nrorg . '/Estrutura:' . $row['NRESTRUTURAM'] . ' ' . $row['NMEVENTO'] . ' - ' . count($arrItens) . ' itens para envio'.PHP_EOL;
            
            foreach($arrItens as $item) {
                $row['NRCHAVE'] = $item['NRCHAVE'];
                $row['NRTABELA'] = isset($item['NRTABELA']) ? $item['NRTABELA'] : null;
                $row['IDOPERACAO'] = isset($item['IDOPERACAO']) ? $item['IDOPERACAO'] : 'I';
                $row['DTMESCOMPETENC'] = $item['DTMESCOMPETENC'];
                $row['NRVINCULOM'] = array_key_exists('NRVINCULOM', $item) ? $item['NRVINCULOM'] : null;
                
                $erro = $this->eSocialService->beforeInsertEnvioCadastros($row['NRESTRUTURAM'], $row['NRTPAMBIENTE'], $row['NREVENTO'], $row['NRCHAVE'], $row['NRTABELA'], $row['IDOPERACAO'], $row['DTMESCOMPETENC'], $this->jenkins);
                
                if(!$erro){
                    $row['NRENVIO'] = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'ESO_ENVIOCADASTROS', 1, 12, true);
                    echo $row['NMEVENTO'] . ' -  insert envio ' . $row['NRENVIO'] . ' chave ' . $item['NRCHAVE'].PHP_EOL;
                    $this->insertEnvioCadastro($row);
                }
            }
        } catch(\Exception $e) {
            echo 'Org:' . $nrorg . '/Estrutura:' . $row['NRESTRUTURAM'] . ' ' . $row['NMEVENTO'] . ' - Erro setEnvioCadastros ('.$e->getMessage().')'.PHP_EOL;
            return;
        }
    }
    
    public function insertEnvioCadastro($row){
        
        $envioCadastros = new $this->envioCadastros;
        $envioCadastros->setNrenvio($row['NRENVIO']);
        $envioCadastros->setNrchave($row['NRCHAVE']);
        $envioCadastros->setNrtabela($row['NRTABELA']);
        $envioCadastros->setIdoperacao($row['IDOPERACAO']);
        $envioCadastros->setDtmescompetenc(DateUtil::getDataDeString(substr($row['DTMESCOMPETENC'], 0, 10), DateUtil::FORMATO_BRASILEIRO, true));
        $envioCadastros->setNrevento($row['NREVENTO']);
        $envioCadastros->setNrestruturam($row['NRESTRUTURAM']);
        $envioCadastros->setNrtpambiente($row['NRTPAMBIENTE']);
        $envioCadastros->setNrvinculom($row['NRVINCULOM']);
        $envioCadastros->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $envioCadastros->setIdstatus('P');
        $envioCadastros->setDtinclusao(DateUtil::getDataAtual());
        $envioCadastros->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $envioCadastros->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $envioCadastros->setDtultatu(DateUtil::getDataAtual());
        $envioCadastros->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $envioCadastros->setCdoperultatu($this->hcmParameters->getCdoperador());
        
        $this->entityManager->persist($envioCadastros);
        $this->entityManager->flush($envioCadastros);
    }
     
    public function setParametrosHcm($nrorg){
        
        $nrtpestrutlegal = 1;
        $nrtpestrutgeren = 6;
        $paramOrg = $this->entityManager->getRepository(Repositories::GPE_PARAMORG)->findOneBy(array('nrorg' => $nrorg));
        
        if($paramOrg){
            $nrtpestrutlegal = $paramOrg->getNrtpestrutlegal();
            $nrtpestrutgeren = $paramOrg->getNrtpestrutgeren();
        }
        
        $paramsHCM = array(
            "cdoperador"        => 1,
            "nmoperador"        => null,
            "nrestruttrab"      => null,
            "nrorgpadrao"       => 0,
            "nrorg"             => $nrorg,
            "nrorgtrab"         => $nrorg,
            "dtmescompetenc"    => DateUtil::setDay(DateUtil::getDataAtual(), 1)->format('d/m/Y'),
            "dtmescompetencdiacorrente" => DateUtil::setDay(DateUtil::getDataAtual(), 1)->format('d/m/Y'),
            "nrtipoestrutlegal" => $nrtpestrutlegal,
            "nrtipoestrutgeren" => $nrtpestrutgeren,
            "idambientesal"     => 'REAL',
            "nrocorrecal"       => 1,
            "nrtpmodalidcal"    => 1,
            "nrtpmodalidsal"    => 1,
            "dataatual"         => DateUtil::getDataAtual(),
            "dtultimodiames"    => DateUtil::getUltimoDiaDoMes(DateUtil::getDataAtual())->format('d/m/Y'),
            "dtultimodiacompetencia" => DateUtil::getUltimoDiaDoMes(DateUtil::getDataAtual())->format('d/m/Y'),
        );
        
        foreach ($paramsHCM as $key => $value) {
            $this->hcmParameters->set($key, $value);
        }
    }
}