<?php

namespace HCM\PTO\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\DateUtil;

class MotivoOcorrenciaFrequenciaController extends Crud {

    protected $dataSourceNameSetMotivoOcorFreq = 'ptoMotivoOcorFreq_setMotivoOcorFreq';

    public function __construct (Manager $dataSourceManager){
        parent::__construct($dataSourceManager);
    }

    public function setMotivoOcorFreq (DTO\Request\DataSet $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameSetMotivoOcorFreq;
        try{
            foreach($request->getDataSet()->getRows() as $row) {
                if($row['__is_new'] === true){
                    $row['DTINCLUSAO'] = $row['DTATUAL'];
                    $row['CDOPERINCLUSAO'] = $row['CDOPERLOG'];
                    $row['NRORGINCLUSAO'] = $row['NRORGTRAB'];
                    $row['DTULTATU'] = $row['DTATUAL'];
                    $row['CDOPERULTATU'] = $row['CDOPERLOG'];
                    $row['NRORGULTATU'] = $row['NRORGTRAB'];
                    $row['NRMOTIVOOCORFREQ'] = \HCM\Util\NovoCodigo::geraCodigo( $row['NRORGTRAB'], 'PTO_MOTIVOOCORFREQ', 1, 12, true);
                } else {
                    $row['DTULTATU'] = $row['DTATUAL'];
                    $row['CDOPERULTATU'] = $row['CDOPERLOG'];
                    $row['NRORGULTATU'] = $row['NRORGTRAB'];
                }
                $row['NRORG'] = $row['NRORGTRAB'];
                if(!array_key_exists('IDATIVO', $row)){
                    $row['IDATIVO'] = 'S';
                }
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function removeMotivoOcorFreq (DTO\Request\DataSet $request, DTO\Response $response){
        try{
            $this->dataSourceName = $this->dataSourceNameSetMotivoOcorFreq;
            parent::delete($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}