<?php
namespace HCM\PTO\Services;

use HCM\PTO\Repository\ApuracaoFrequenciaRepository;
use Doctrine\ORM\EntityManager; 
use HCM\Util\DateUtil;

class ApuracaoFrequenciaService {

    /**
     * @var apuracaoFrequenciaRepository
     */
    protected $apuracaoFrequenciaRepository;
    
    // Tempos mínimos de intervalos
    const TEMPO_JORNADA_INTERVALO_15_TEMPO_MAX  = 6;
    const TEMPO_JORNADA_INTERVALO_15_TEMPO_MIN  = 4;
    
    // Constants usadas para validação
    const APUR_TEMPO_MAXIMO_SEM_ALMOCO          = 6;
    const APUR_TEMPO_MINIMO_ALMOCO              = 1;
    const APUR_TEMPO_MIN_SEM_ALMOCO             = 4;

    public function __construct(EntityManager $entityManager, ApuracaoFrequenciaRepository $apuracaoFrequenciaRepository) {
        $this->entityManager = $entityManager;
        $this->apuracaoFrequenciaRepository = $apuracaoFrequenciaRepository;
    }

    /**
     * @return int
     */    
    public function getVinculosPorSelecaoNRescindidos ($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrOrgPadrao, $nrOrg, $apuraRescindidos, $fimPeriodo, $iniPeriodo) {
        $result = $this->apuracaoFrequenciaRepository->getVinculosPorSelecaoNRescindidos($criterio, $inicio, $fim, $dtCompetencia, $nrTipoVinculo, $nrOrgPadrao, $nrOrg, $apuraRescindidos, $fimPeriodo, $iniPeriodo);
        return $result;
    }

    public function getResumoSituFreqVinculo ($nrOrg, $nrVinculom, $nrPeriododApuracao) {
        $result = $this->apuracaoFrequenciaRepository->getResumoSituFreqVinculo($nrOrg, $nrVinculom, $nrPeriododApuracao);
        return $result;
    }

    public function verificaControleJornada ($nrOrg, $nrvinculom, $fimPeriodo) {
        $result = $this->apuracaoFrequenciaRepository->verificaControleJornada($nrOrg, $nrvinculom, $fimPeriodo);
        return $result;
    }

    public function deleteMarcacoes ($nrorg, $nrvinculom, $nrperiodoapuracao) {
        $result = $this->apuracaoFrequenciaRepository->deleteMarcacoes($nrorg, $nrvinculom, $nrperiodoapuracao);
    }

    public function deleteIntervalos ($nrorg, $nrvinculom, $nrperiodoapuracao) {
        $result = $this->apuracaoFrequenciaRepository->deleteIntervalos($nrorg, $nrvinculom, $nrperiodoapuracao);
    }

    public function deleteResumos ($nrorg, $nrvinculom, $nrperiodoapuracao) {
        $result = $this->apuracaoFrequenciaRepository->deleteResumos($nrorg, $nrvinculom, $nrperiodoapuracao);
    }

    public function updateMarcacoesAlteradas ($nrorg, $nrvinculom, $nrperiodoapuracao) {
        return $this->apuracaoFrequenciaRepository->updateMarcacoesAlteradas($nrorg, $nrvinculom, $nrperiodoapuracao);
    }

    public function updateNovoCodigoResumos ($nrOrg) {
        return $this->apuracaoFrequenciaRepository->updateNovoCodigoResumos($nrOrg);
    }

    public function updateNovoCodigoMarcacoes ($nrOrg) {
        return $this->apuracaoFrequenciaRepository->updateNovoCodigoMarcacoes($nrOrg);
    }

    public function updateNovoCodigoIntervalos ($nrOrg) {
        return $this->apuracaoFrequenciaRepository->updateNovoCodigoIntervalos($nrOrg);
    }

    public function getPeriodoSimulacao($parameters) {
        return $this->apuracaoFrequenciaRepository->getPeriodoSimulacao($parameters);
    }

    public function getVinculosSimulacao($parameters) {
        return $this->apuracaoFrequenciaRepository->getVinculosSimulacao($parameters['CRITERIO'], $parameters['DSINICIO'], $parameters['DSFIM'], $parameters['DTMESCOMPETENC'], $parameters['NRTIPOVINCULOM'], $parameters['NRORGPADRAO'], $parameters['NRORG']);
    }
} 