<?php
namespace HCM\Util;

class Messages {

    const PADRAO_EVALUATE = "/\@(.*)\@/";
    const PADRAO_EVALUATE_2 = "/\@[\s\S]+?\@/";

    const SUCCESS_MESSAGE_CODE = 10;
    const ALERT_MESSAGE_CODE = 20;
    const ERROR_MESSAGE_CODE = 30;

    /* + ----------------------------------- +
     * | Error messages                      |
     * + ----------------------------------- + */
     
    const SAVE_ERROR_MESSAGE = 'Erro ao salvar registro';
    const DELETE_ERROR_MESSAGE = 'Erro ao apagar registro';
    
    const HCM00000_GER_DTNASC_PESS_N_INF_ERROR = "Data de nascimento da pessoa @PESSOA@ não informada";
    const HCM00000_GER_VINCS_SEM_DEPENDENTES_ERROR = "Vínculos informados não possuem dependentes cadastrados";

    const HCM00000_EDITAR_EXCLUIR_REGISTRO_AFASTAMENTO =  "Operação com chave @nrchave@ bloqueada. O registro já existe dentre as informações disponibilizadas para o eSocial.";
    const HCM00000_GER_ALTEESCALA_DATA_ALREADY_EXIST_ERROR = "Já existe uma alteração de escala de trabalho com esta data";
    const HCM00000_GER_ALTEOCUPACAO_DATA_ALREADY_EXIST_ERROR = "Já existe uma alteração de ocupação com esta data";
    const HCM00000_GER_ALTESALARIO_DATA_OCOR_ALREADY_EXIST_ERROR = "Já existe uma alteração de salário com esta data e esta ocorrência";
    const HCM00000_GER_ALTESITUFUNC_DATA_ALREADY_EXIST_ERROR = "Já existe uma alteração de situação funcional com esta data";
    const HCM00000_GPE_ALTESITUFUNC_QTD_ATESTADOS_CID_LIMITE_ERROR = "IMPOSSÍVEL LANÇAR NOVOS ATESTADOS PARA O CID @CDTABECDI@.<br>Quantidade de atestados para o CID @CDTABECDI@ nos últimos @NRDIARETROATIVA@ dias superior a @QTDIASLIMITSITU@";
    const HCM00000_GPE_ALTESTABVINC_GERAR_ESTAB_ERROR = "Não foi possível criar estabilidade posterior pois vínculo já possui estabilidade no período de @DTINIESTABVINC@ a @DTFIMESTABVINC@";
    const HCM00000_GPE_MOVIMENTACAO_LEGAL_TIPOESTRUT_ERROR = "Movimentaçao legal incompatível com o tipo de estrutura";
    const HCM00000_GPE_MOVIMENTACAO_GEREN_TIPOESTRUT_ERROR = "Movimentaçao gerencial incompatível com o tipo de estrutura";
    const HCM00000_GER_MOVIMENTACAO_DATA_ALREADY_EXIST_ERROR = "Já existe uma movimentação na mesma data para este tipo de estrutura";
    const HCM00000_GER_MOVIMENTACAO_DATA_ALREADY_EXIST_LIST = "Vinculos com movimentação já existente na mesma data para este tipo de estrutura:<br>@VINCULOS@";
    const HCM00000_GER_MOVIMENTACAO_NOT_FOUND = "Não foram encontradas movimentações";
    const HCM00000_GER_VINCS_N_ENCONT_NOMES_ERROR = "Não foram encontrados vínculos para os nomes informados";
    const HCM00000_GER_VINCS_N_ENCONT_MATRICS_ERROR = "Não foram encontrados vínculos para as matrículas informadas";
    const HCM00000_GER_VINCS_N_ENCONT_DATAS_ERROR = "Não foram encontrados vínculos para as datas informadas";
    const HCM00000_GER_VINCS_N_ENCONT_ESTRUTS_ERROR = "Não foram encontrados vínculos para as estruturas informadas";
    const HCM00000_GER_VINCS_N_ENCONT_LISTA_ERROR = "Não foram encontrados vínculos para a(s) lista(s) informada(s)";
    const HCM00000_GER_VINC_N_ENCONTR_FILTRO_INF_ERROR = "Não foram encontrados vínculos para o filtro informado";
    const HCM00000_GER_VERIF_PARAM_STR_N_ENCONTR_ERROR = "O parãmetro '%s' não foi encontrado";
    const HCM00000_GER_VERIF_PARAM_STR_S_VALOR_ERROR = "O parãmetro '%s' não possui valor. Favor informar o valor na aba 'Parâmetros'.";
    const HCM00000_GER_VERIF_N_ENCONTR_PARAM_ERROR = "Não foram encontrados parâmetros na consulta. Os parâmetros devem ser iniciados por ':P_'.";
    const HCM00000_GER_PERFILACESSO_ALREADY_EXIST_ERROR = "Perfil de acesso já cadastrado";
    const HCM00000_GER_SERVPAT_ALREADY_EXIST_VINCULO_ERROR = "Existe vínculo relacionado a esta PAT";
    const HCM00000_GER_SERVPAT_VINCULO_CADASTRADO_ERROR = "Este vínculo ja esta cadastrado nesta PAT";
    const HCM00000_GER_TIPOVINCULO_ALREADY_EXIST_PROCESSO_ERROR = "Existe processo relacionado a este tipo de vínculo";
    const HCM00000_GER_CALENDARIO_ALREADY_EXIST_FERIADO_ERROR = "Existe feriados relacionados a este calendario";
    const HCM00000_GER_BANCO_ALREADY_EXIST_AGENCIA_ERROR = "Existe agencias relacionadas a este banco";
    const HCM00000_GER_PESSOA_VINCULOCLT_ERROR = "Para vínculos CLT é necessário cadastrar:";
    const HCM00000_GER_PESSOA_VINCULO_ERROR = "Pessoa possui vínculo, logo precisa ter um CPF válido.";
    const HCM00000_GER_PESSOA_PIS_ERROR = "PIS já cadastrado para a pessoa: ";
    const HCM00000_GER_PESSOA_CPF_ERROR = "CPF já cadastrado para a pessoa: ";
    const HCM00000_GER_VINCULO_POSSUI_ITENSDECALC_ERROR = "Não foi possível cancelar a admissão pois o vínculo possui itens de cálculo. Favor excluir todos os itens para cancelar a admissão.";
    const HCM00000_GER_VINC_FALTAESTRUTSIND = "O vínculo @NMVINCULOM@ não possui estrutura sindical cadastrada";
    const HCM00000_GER_EMAIL_OPERADOR_CADASTRADO = "O email já esta cadastrado para o operador @NMOPERADOR@";
    const HCM00000_GER_NAO_POSSIVEL_GRAVAR_ARQUIVO = "Não foi possível gravar o arquivo";
    const HCM00102_GER_DUPLICATE_CODE_OR_NAME_ERROR = "Impossível salvar.<br>O código ou o nome já existe";
    const HCM00102_GER_DUPLICATE_ACRONYM_OR_NAME_ERROR = "Impossível salvar.<br>A sigla ou o nome já existe";
    const HCM00102_GER_DUPLICATE_NAME_ERROR = "Impossível salvar.<br>O nome já existe";
    const HCM00102_GER_REGISTROS_FILHOS_ERROR = "Impossível excluir.<br>Existem registros filhos";
    const HCM00048_GER_EVENTO_ADMISSAO_ENVIADO = "Não é possível realizar o cancelamento da admissão pois os dados do vínculo já foram enviados para o eSocial.";
    const HCM00048_GER_EVENTO_ADMISSAO_ENVIADO_TEXTO_COMPLEMENTAR_AVISO = "Também não foi possível realizar o cancelamento da admissão pois os dados do vínculo já foram enviados para o eSocial.";
    const HCM00108_GER_STATUS_DOCUMENTO_INVALIDO = "Status de aprovação de documento inválido.";
    const HCM01000_FPA_CALCULOCONSUMER_JENKINS = "Não foi possível inicializar o consumidor via Jenkis, favor verificar.";
    const HCM01000_FPA_BLOQ_OPER_VINC_LIQ_ERROR = "Operação bloqueada. Vínculo possui líquido para este movimento";
    const HCM01000_FPA_ITEM_CALC_UNIQ_ERROR = "Item de cálculo já existente para mesmo movimento, evento, vinculo e data de ocorrência";
    const HCM01000_FPA_VINC_EVENT_BENEF_ERROR = "Operação bloqueada. Evento relacionado está sendo utilizado no cadastro de benefícios";
    const HCM01000_FPA_VINC_CALCULADO_ERROR = "Operação bloqueada. Vínculo já calculado.";
    const HCM01000_FPA_VINC_CALC_FV_RETROC_ERROR = "Vínculo(s) já calculado(s). Favor retroceder";
    const HCM01000_FPA_VINC_PARCIAL_ERROR = "Operação bloqueada. Vínculo com parcial gravado. Favor gravar total.";
    const HCM01000_FPA_LOTELANCEVEN_ORIG_UNDEFINED = "Não foi definida origem do lote de eventos";
    const HCM01000_FPA_TPCALCULO_ALREADY_EXIST_MOVIMENTO_ERROR = "Existe movimento relacionado a este tipo de calculo";
    const HCM01000_FPA_TPMOVIMENTO_ALREADY_EXIST_CALCFOLHA_ERROR = "Existe calculo folha relacionado a este movimento";
    const HCM01000_FPA_GRUPINCID_EXISTS_ITEM_ERROR = "Existe item relacionado a este grupo de incidência.";
    const HCM01000_FPA_ERROR_SAVE_REPORT_VINCULO = "Não foi possivel salvar o relatório para o vinculo @NMVINCULOM@";
    const HCM01000_FPA_ERROR_SAVE_REPORT = "Não foi possivel salvar o relatório";
    const HCM01000_FPA_FERIAS_EXISTS_GOZOFERIAS_ERROR = "Existe gozo cadastrado para essa ferias.";
    const HCM01000_FPA_GOZOFERIAS_VINCPOSSUIPERIODO_ERROR = "Vínculo já possui um período de gozo de @DTINIGOZOFERIAS@ a @DTFIMGOZOFERIAS@ Favor informar outra data";
    const HCM01000_FPA_GOZOFERIAS_VINCPOSSUIPERIODO_SITUFUNC_ERROR = "Vínculo possui afastamento durante o período de gozo @DTINISITUFUNC@ a @DTFIMSITUFUNC@";
    const HCM01000_FPA_NENHUM_VINCULO_COM_CALCULO = "Os vínculos <br><br>@VINCULOS@<br><br> não possuem cálculo.";
    const HCM01000_FPA_NENHUM_RESP_INFORM_COM_EMAIL = "Os responsáveis informais das estruturas gerenciais<br><br>@ESTRUTURAS@<br><br> não possuem e-mail";
    const HCM01000_FPA_SEM_CALC_SEM_EMAIL = "Nenhum holerite foi enviado: <br><br>Os vínculos <br>@SEMCALC@<br> não possuem cálculo. <br><br>Os responsáveis das estruturas gerenciais<br>@SEMEMAIL@<br> não possuem e-mail.";

    const HCM02000_VAB_BENEFICIO_ALT_ESTRUT_ERROR = "Não é possível alterar a estrutura, benefício possui beneficiários cadastrados";
    const HCM02000_VAB_BENEFICIO_ALT_TPPER_ERROR = "Não é possível alterar o tipo de período, benefício possui beneficiários cadastrados";
    const HCM02000_VAB_BENEFICIO_FX_ETARIA_N_ENCONT_ERROR = "Não foi encontrado valor na tabela de faixa etária";
    const HCM02000_VAB_BENEFICIARIO_N_ENCONTR_ERROR = "Não foram encontrados beneficiários cadastrados";
    const HCM02000_VAB_BENEFICIARIO_VINC_N_ENCONTR_ERROR = "Não foram encontrados beneficiários para os vínculos";
    const HCM02000_VAB_BENEFICIARIO_JA_CADASTRADO_ERROR = "Beneficiário já cadastrado";
    const HCM02000_VAB_VINC_EXPORTADO_FOLHA_ERROR = "Operação bloqueada. Existe(m) vínculo(s) exportado(s) para a folha.";
    const HCM02000_VAB_EVEN_EXPORTADO_FOLHA_ERROR = "Operação bloqueada. Evento exportado para a folha.";
    const HCM02000_VAB_ITENS_BENEF_VAZIO_ERROR = "Não foram encontrados itens de lançamentos de benefícios";
    const HCM02000_VAB_VINC_GRAVAD_RETROC_BENEF_ERROR = "Existem vínculos com líquido gravado. Favor retroceder itens no lançamento de benefícios";
    const HCM02014_VAB_BENEFICIARIO_SEM_CPF = "Pessoa do beneficiário sem CPF.";
    const HCM02015_VAB_NENHUM_BENEFICIO_CALCULADO = "Nenhum benefício calculado";
    const HCM02015_VAB_NENHUM_CALCULO_RETROCEDIDO = "Nenhum cálculo retrocedido";

    const HCM03000_AVL_CRITERIORESUL_EXISTS_FAIXACRITRESULT_ERROR = "Existe faixa relacionado a este críterio";
    const HCM03000_AVL_QUESTAO_POSSUI_REGISTROSFILHOS = "Esta Questão possui dados ligados a ela, verifique 'Respostas', 'Tipos de Avaliações que utilizam a questão' e 'Nível da questão por nível de avaliação'";
    const HCM03000_AVL_NIVELAVAL_AVALPOSSUIQUEST = "Este Nível de Avaliações possui Questões vinculadas a ele.";
    const HCM03000_AVL_TIPOAVAL_AVALPOSSUIQUEST = "Este Tipo de Avaliações possui Questões vinculadas a ele.";
    const HCM03000_AVL_CRITERIO_RESULTADO_NAO_DEFINIDO = "Critério de Resultado ou Faixa não definidos para esta avaliação";
    const HCM03000_AVL_VERIFIQUE_TIPO_DE_RELACIONAMENTO_POR_AVALIACAO = "Verifique se existe Tipo de Relacionamento por Avaliação";
    const HCM03000_AVL_AVALIADORES_NAO_ENCONTRADOS = "Não foram encontrados avaliadores com avaliação concluída ou já foram apurados.";
    const HCM03000_AVL_VINCULO_JA_NOTIFICADO = "O Vínculo @NMVINCULOM@ já foi notificado";
    const HCM03000_AVL_IMPORTA_REGISTROS = "Registros importados com sucesso!";
    const HCM03000_AVL_CRITERIORESUL_EXISTS_AVALIACAO_QUESTIONARIO_ERROR = "Não foi possível excluir pois há avaliações ou questionários modelo associadas a esse critério";
    const HCM03000_AVL_CRITERIO_SALVO_SUCESSO = "O critério foi salvo com sucesso!";
    const HCM03000_AVL_CRITERIO_APAGADO_SUCESSO = "O critério foi apagado com sucesso!";
    const HCM03000_AVL_FAIXA_APAGADA_SUCESSO = "As faixas foram apagadas com sucesso!";
    const HCM03000_AVL_FAIXA_VINCULADAS = "Este Critério de Resultado possui Faixas de Valores vinculadas a ele, deseja deletá-las e então deletar o critério?";

    const HCM05000_SST_REUNIAO_EXISTS_PAUTA_ERROR = "Existe pauta relacionada a esta reunião.";
    const HCM05000_SST_REUNIAO_EXISTS_DELIBERACAO_ERROR = "Existe deliberação relacionada a esta reunião.";
    const HCM05000_SST_REUNIAO_EXISTS_PARTICIPANTES_ERROR = "Existe participante relacionado a esta reunião.";
    const HCM05000_SST_REUNIAO_EXISTS_PARTICIPANTESCADASTRADO_ERROR = "Participante já cadastrado";
    const HCM05000_SST_COMITE_EXISTS_PARTICIPANTES_ERROR = "Existe participante relacionado a este comitê.";
    const HCM05000_SST_COMITE_EXISTS_REUNIAO_ERROR = "Existe reunião relacionada a este comitê.";
    const HCM05000_SST_EXAME_EXISTS_ITEM_ERROR = "Existem itens relacionados a este exame";
    const HCM05000_SST_ITEMEXAME_EXISTS_REFERENCIA_ERROR = "Existem referências relacionados a este item";
    const HCM05000_SST_REFITEMEXAME_EXISTS_FAIXA_ERROR = "Existem faixas de valores relacionadas a esta referência";
    const HCM05000_SST_REFITEMEXAME_EXISTS_CLASSIF_ERROR = "Existem classificações relacionadas a esta referência";
    const HCM05000_SST_OCORRENCIA_EXISTS_VITIMA_ERROR = "Existe vítima relacionada a esta ocorrência.";
    const HCM05000_SST_VITIMA_EXISTS_PARTEATING_ERROR = "Existe parte atingida relacionada a esta vítima.";
    const HCM05000_SST_OCORRENCIA_EXISTS_VITIMACADASTRADA_ERROR = "Vítima já cadastrada";
    const HCM05000_SST_PERFILEXAME_EXISTS_ITEMPERFILEXAME_ERROR = "Existe item relacionado a este perfil.";
    const HCM05000_SST_PROGENTREPI_DADOS_NOT_FOUND_ERROR = "Não foram encontrados dados para programação de entrega de EPI";
    const HCM05000_SST_FICHAMEDICA_EXISTS_EXAME_ERROR = "Existe exame relacionado a esta ficha médica.";
    const HCM05000_SST_FICHAMEDICA_EXISTS_DOENCA_ERROR = "Existe doença relacionada a esta ficha médica.";
    const HCM05000_SST_EXAMEFICHAMED_EXISTS_ITEMEXAME_ERROR = "Existe item relacionado a este exame.";
    const HCM05000_SST_PROGEXAMES_DADOS_NOT_FOUND_ERROR = "Não foram encontrados dados para programação de exames periódicos";
    const HCM05000_FPA_TABELAFOLHA_EXISTS_FAIXATABELA_ERROR = "Existe faixa para essa tabela";

    const HCM09000_ESO_CALLED_EVENTO_ERROR = "HCM09000_ESO_CALLED_EVENTO_ERROR";
    const HCM09000_ESO_CARGAINI_EXISTS_ERROR = "HCM09000_ESO_CARGAINI_EXISTS_ERROR";
    const HCM09000_ESO_CERTIFICADO_NOT_FOUND_ERROR = "HCM09000_ESO_CERTIFICADO_NOT_FOUND_ERROR";
    const HCM09000_ESO_CERTIFICADO_NOT_OPEN_ERROR = "HCM09000_ESO_CERTIFICADO_NOT_OPEN_ERROR";
    const HCM09000_ESO_CERTIFICADO_VALIDADE_ERROR = "HCM09000_ESO_CERTIFICADO_VALIDADE_ERROR";
    const HCM09000_ESO_ENVIOS_NOT_FOUND_ERROR = "HCM09000_ESO_ENVIOS_NOT_FOUND_ERROR";
    const HCM09000_ESO_FILE_LOTE_NOT_FOUND_ERROR = "HCM09000_ESO_FILE_LOTE_NOT_FOUND_ERROR";
    const HCM09000_ESO_GENERATE_CERT_KEY_ERROR = "HCM09000_ESO_GENERATE_CERT_KEY_ERROR";
    const HCM09000_ESO_IDEVENTO_INVALID_ERROR = "HCM09000_ESO_IDEVENTO_INVALID_ERROR";
    const HCM09000_ESO_INSCR_TRANSM_NOT_FOUND_ERROR = "HCM09000_ESO_INSCR_TRANSM_NOT_FOUND_ERROR";
    const HCM09000_ESO_LOTE_STATUS_ERROR = "HCM09000_ESO_LOTE_STATUS_ERROR";
    const HCM09000_ESO_PARAMETRO_NOT_FOUND_ERROR = "HCM09000_ESO_PARAMETRO_NOT_FOUND_ERROR";
    const HCM09000_ESO_PRODREST_OPER_ERROR = "HCM09000_ESO_PRODREST_OPER_ERROR";
    const HCM09000_ESO_SENHA_CERTIFICADO_NOT_FOUND_ERROR = "HCM09000_ESO_SENHA_CERTIFICADO_NOT_FOUND_ERROR";
    const HCM09000_ESO_TPINSCEMPREG_ERROR = "HCM09000_ESO_TPINSCEMPREG_ERROR";
    const HCM09000_ESO_TPINSCTRANSM_ERROR = "HCM09000_ESO_TPINSCTRANSM_ERROR";
    const HCM09000_ESO_UNIQUE_ENVIO_ERROR = "HCM09000_ESO_UNIQUE_ENVIO_ERROR";
    const HCM09000_ESO_FILE_CONSULTA_NOT_FOUND_ERROR = "HCM09000_ESO_FILE_CONSULTA_NOT_FOUND_ERROR";
    const HCM09000_ESO_ESTRUTURA_FECHAMENTO_EXISTS_ERROR = "Estrutura @NRESTRUTURAM@ já possui evento de fechamento (3035)";
    const HCM90000_ESO_FERIAS_COM_SALDO = "O vínculo @NRVINCULOM@ possui um saldo de férias de @QTDIASSALDO@ dia(s) para gozar.";
    
    
    const HCM07009_PTO_REGISTRO_FILHO_ERROR                 = "Impossível excluir.<br>Existe registro filho.";
    const HCM07018_PTO_OCORR_NOT_FOUND                      = "Não foi encontrada a ocorrência para a realização do processo.";
    const HCM07018_PTO_OCORR_NO_FILE                        = "A ocorrência não possui documentos associados.";
    const HCM07003_PTO_SAVE_MARC_DATA_HORA_MARCACAO_ILLEGAL = "Não foi possível salvar o registro pois a data-hora de marcação possui inconsistências.";
    const HCM07003_PTO_OCORR_ALMOCO_ALREADY_EXISTS          = "Já existe uma ocorrência de almoço relacionada à essa marcação.";
    const HCM07003_PTO_MARC_NOT_FOUND                       = "Não foi encontrada marcação para a realização do processo.";
    const HCM07003_PTO_MARC_DTHRMARC_NOT_EXIST              = "Não foi encontrada a data de batida da marcação.";
    const HCM07003_PTO_DADOS_HORARIO_NOT_FOUND              = "Não foi possível encontrar os dados de horário do vínculo.";
    const HCM07003_CADAUTO_UNSUFICCIENT_FILTERS             = 'Não foram informados todos os filtros esperados. Preencha os filtros de dia, estrutura e/ou vínculo e tente novamente.';
    const HCM07003_CADAUTO_UNSUFICCIENT_ITEMS               = 'Não foram informadas marcações a serem incluídas. Preencha pelo menos uma marcação.';
    
    const ORG_NOT_FOUND = "A organização não foi encontrada";
    
    const AVISO_ESO_PENSALIDADE_REGISTRO_DATA = "Atenção! Registro com data sujeita a penalidade do eSocial conforme Art. 22 da CLT – Lei 8.213/91";

    /* + ----------------------------------- +
     * | Successful messages                 |
     * + ----------------------------------- + */
    const HCM00001_GER_IMPORTACAO_SUCESS = "Importação realizada com sucesso";
    const HCM00000_GER_VERIF_SAVE_SUCCESS = "A validação foi salva com sucesso. Favor informar valor para os parâmetros";
    const HCM00000_GPE_ALTESITUFUNC_PROXSITUFUNC_CAD_AUTO_SUCCESS = "Próxima situação funcional gerada automaticamente";
    const HCM00000_GPE_ALTESTABVINC_GERAR_ESTAB_SUCCESS = "Criada estabilidade posterior no período de @DTINIESTABVINC@ a @DTFIMESTABVINC@";
    const HCM00000_GER_MOVIMENTACAO_GERACAO_SUCCESS = "Movimentações geradas com sucesso";

    /* + ----------------------------------- +
     * | Alert messages                      |
     * + ----------------------------------- + */
    const HCM01000_FPA_DEPVINCULO_DEPEND_EXISTE_TIPODEPENDE = "Dependente já cadastrado para o tipo de dependência informado";
    const HCM01000_FPA_RETROCED_ITENS_N_ENCONT_ALERT = "Não foram encontrados itens para retroceder";
    const HCM01000_FPA_VINC_EMAIL_NOTFOUND = "Os Vínculos <br> @NMVINCULOM@ <br> não possuem email.\n";
    const HCM01000_FPA_ESTRUT_GERENC_EMAIL_NOTFOUND = "Os Responsáveis Informais das Estruturas Gerenciais <br> @ESTRUTURAG@ <br> não possuem email.\n";
    const HCM01000_FPA_VINC_OPERADOR_NOTFOUND = "Os Vínculos <br> @NMVINCULOM@ <br> não possuem operador";
    const HCM01000_FPA_VINC_SEM_LIQUIDO = "Os Vínculos <br> @NRVINCULOM@ <br> não possuem líquido.\n";
    const HCM01000_FPA_CANCELAMENTO_FERIAS_EXISTEM_VINCULOS_COM_LIQUIDO_FERIAS = "Foram encontrados um ou mais vínculos que possuem férias calculadas na respectiva competência <br /> (<vinculos>).  <br />Deseja prosseguir?";
    const HCM01000_FPA_SEND_EMAIL_SUCCES = "Demonstrativo enviado para os responsáveis informais das estruturas gerenciais.";
    
    const HCM01020_FPA_EXPORTACAO_LOTE_NAO_CANCELADA = "Exportação do lote não cancelada.";
    const HCM01020_FPA_NAO_HA_ITEM_PARA_EXPORTAR = "Não há itens cadastrados para exportar.";
    const HCM01020_FPA_NENHUM_ITEM_EXPORTADO = "Nenhum item exportado.";
    const HCM01020_FPA_NAO_HA_EXPORTACAO_PARA_CANCELAR = "Não há exportação para cancelar.";
    const HCM01020_FPA_NR_LOTE_RESUMO_SITU_FREQ_EXLUIDOS = "Geração de novo lote desbloqueada.";
    
    const HCM00000_GER_VERIF_SAVE_SUCCESS_N_ENCONTR_PARAM = "A validação foi salva com sucesso. Não foram encontrados parâmetros na consulta. Os parâmetros devem ser iniciados por ':P_'.";
    const HCM00000_GPE_ALTESALARIO_VRSALARIO_MENOR_SALMINIMO = "O valor de salário informado é menor que o valor do Salário Mínimo";
    const HCM00000_GPE_ALTESITUFUNC_QTD_ATESTADOS_CID_LIMITE = "Quantidade de atestados para o CID @CDTABECDI@ nos últimos @NRDIARETROATIVA@ dias é superior a @QTDIASLIMITSITU@. <br> Data do atestado limitada para @NOVADATA@";
    const HCM00000_GPE_ALTESITUFUNC_EXISTE_ATUALIZADA_AFASTAMENTO = "Já existe Situação Funcional para o mesmo CID: @CDTABECDI@. Situação atualizada para Afastamento";
    const HCM00000_GPE_ALTESITUFUNC_VINC_POSSUI_POSTERIOR = "Vínculo @NRVINCULOM@-@NMVINCULOM@ possui situação funcional posterior (Início:@DTINISITUFUNC@)";
    const HCM00000_GPE_ALTESITUFUNC_VINC_N_ENCONTRADA = "Situação funcional não encontrada para o vínculo @NRVINCULOM@-@NMVINCULOM@";
    const HCM00000_GPE_ALTESITUFUNC_VINC_N_POSSUI_ANTERIOR = "Vínculo @NRVINCULOM@-@NMVINCULOM@ sem situação funcional anterior";
    const HCM00000_GPE_ALTESTABVINC_PERIDO_EXIST = "Vínculo possui estabilidade no período de @DTINIESTABVINC@ a @DTFIMESTABVINC@";
    const HCM00000_GER_MOVIMENTACAO_GERACAO_ALERT = "Não foram geradas movimentações";
    const HCM00048_GPE_PESSOA_FORMACOMUNICACAO_EXISTENTE_ALERT = "Forma de comunicação deste tipo já cadastrada.";
    const HCM00048_GPE_PESSOA_ENDERECO_EXISTENTE_ALERT = "Endereço deste tipo já cadastrado.";
    const HCM00048_GPE_PESSOA_RELACIONAMENTO_EXISTENTE_ALERT = "Não é possível cadastrar outro relacionamento deste tipo.";
    
    
    // Geral  
    const HCM01000_ERROR_ZIP = 'Erro ao <br> @zip_message@ <br> arquivo Zip.';
    const FILE_NOT_FOUND = 'ARQUIVO NÃO ENCONTRADO';
    const DATE_FORMAT_NOT_ESPECTED = 'O formato de data informado não é o esperado pelo sistema. Por favor altere o valor inserido e tente novamente';

    public function __construct(){}

    public function setMensagem($mensagem) {
        $this->mensagem = $mensagem;
    }

    public function getMensagem() {
        return $this->mensagem();
    }

    public static function evaluateMessage($content, $replace) {
        if (is_array($replace)) {
            return preg_replace_callback(self::PADRAO_EVALUATE_2, function($matches) use (&$replace) {
                return array_shift($replace);
            }, $content);
        } else {
            return preg_replace(self::PADRAO_EVALUATE, $replace, $content);
        }
    }
} 