<?php
namespace Folha\Entities;

class GpeMovimentacao extends Base\GpeMovimentacao
{

	// LISTA DE MÉTODOS UTILIZADOS EXCLUISIVAMENTE NA MIGRACAO ALINUTRI.
    public static function geraNovoCodigoMigracao($nrtipotransfer, $nrtpmovtransfm, $nrvinculom, $dtinimoviment, $nrorg)
    {
        if (!$dtinimoviment instanceof \DateTime) {
            $dtinimoviment = \HCM\Util\DateUtil::getDataDeString(
                $dtinimoviment, \HCM\Util\DateUtil::FORMATO_BRASILEIRO, true
            );
        }

        if (is_numeric($nrvinculom)) {
	        $movimentacao = self::findOneByNrtipotransferAndNrtpmovtransfmAndNrvinculomAndDtinimovimentAndNrorg(
	        	$nrtipotransfer, $nrtpmovtransfm, $nrvinculom, $dtinimoviment, $nrorg
	    	);
        }

    	if (isset($movimentacao) && $movimentacao instanceof \Folha\Entities\GpeMovimentacao) {
    		$nrmovimentacao = $movimentacao->getNrmovimentacao();
    	} else {
    		$nrmovimentacao = \Geral\Util\NovoCodigo::geraNovoCodigoMigracao(
    			'GPE_MOVIMENTACAO', 'NRMOVIMENTACAO', $nrorg
			);
    	}

    	return $nrmovimentacao;
    }

}